;************************************************************************
;
;	J[l
;
;************************************************************************

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		KERNEL_LOAD						; J[l̃[hAhX

[BITS 32]
;************************************************************************
;	Gg|Cg
;************************************************************************
kernel:
		;---------------------------------------
		; tHgAhX擾
		;---------------------------------------
		mov		esi, BOOT_LOAD + SECT_SIZE		; ESI   = 0x7C00 + 512
		movzx	eax, word [esi + 0]				; EAX   = [ESI + 0] // ZOg
		movzx	ebx, word [esi + 2]				; EBX   = [ESI + 2] // ItZbg
		shl		eax, 4							; EAX <<= 4;
		add		eax, ebx						; EAX  += EBX;
		mov		[FONT_ADR], eax					; FONT_ADR[0] = EAX;

		;---------------------------------------
		; ̕\
		;---------------------------------------
		cdecl	draw_char, 0, 0, 0x010F, 'A'
		cdecl	draw_char, 1, 0, 0x010F, 'B'
		cdecl	draw_char, 2, 0, 0x010F, 'C'

		cdecl	draw_char, 0, 0, 0x0402, '0'
		cdecl	draw_char, 1, 0, 0x0212, '1'
		cdecl	draw_char, 2, 0, 0x0212, '_'

		;---------------------------------------
		; ̏I
		;---------------------------------------
		jmp		$								; while (1) ; // [v

ALIGN 4, db 0
FONT_ADR:	dd	0

;************************************************************************
;	W[
;************************************************************************
%include	"../modules/protect/vga.s"
%include	"../modules/protect/draw_char.s"

;************************************************************************
;	pfBO
;************************************************************************
		times KERNEL_SIZE - ($ - $$) db 0x00	; pfBO

