;************************************************************************
;	BIOSŃ[hŏ̃ZN^
;	
;	vOŜʂāAZOg̒l0x0000ƂB
;	(DS==ES==0)
;	
;************************************************************************

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		BOOT_LOAD						; [hAhXAZuɎw

;************************************************************************
;	Gg|Cg
;************************************************************************
entry:
		;---------------------------------------
		; BPB(BIOS Parameter Block)
		;---------------------------------------
		jmp		ipl								; 0x00( 3) u[gR[hւ̃Wv
		times	3 - ($ - $$) db 0x90			; 
		db		'OEM-NAME'						; 0x03( 8) OEM
												; -------- --------------------------------
		dw		512								; 0x0B( 2) ZN^̃oCg
		db		1								; 0x0D( 1) NX^̃ZN^
		dw		32								; 0x0E( 2) \ZN^
		db		2								; 0x10( 1) FAT
		dw		512								; 0x11( 2) [gGg
		dw		0xFFF0							; 0x13( 2) ZN^16
		db		0xF8							; 0x15( 1) fBA^Cv
		dw		256								; 0x16( 2) FAT̃ZN^
		dw		0x10							; 0x18( 2) gbÑZN^
		dw		2								; 0x1A( 2) wbh
		dd		0								; 0x1C( 4) BꂽZN^
												; -------- --------------------------------
		dd		0								; 0x20( 4) ZN^32
		db		0x80							; 0x24( 1) hCuԍ
		db		0								; 0x25( 1) i\j
		db		0x29							; 0x26( 1) u[gtO
		dd		0xbeef							; 0x27( 4) VAio[
		db		'BOOTABLE   '					; 0x2B(11) {[x
		db		'FAT16   '						; 0x36( 8) FAT^Cv

		;---------------------------------------
		; IPL(Initial Program Loader)
		;---------------------------------------
ipl:
		cli										; // 荞݋֎~

		mov		ax, 0x0000						; AX = 0x0000;
		mov		ds, ax							; DS = 0x0000;
		mov		es, ax							; ES = 0x0000;
		mov		ss, ax							; SS = 0x0000;
		mov		sp, BOOT_LOAD					; SP = 0x7C00;

		sti										; // 荞݋

		mov		[BOOT + drive.no], dl			; u[ghCuۑ

		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0						; puts(.s0);

		;---------------------------------------
		; c̃ZN^Sēǂݍ
		;---------------------------------------
		mov		bx, BOOT_SECT - 1				; BX = c̃u[gZN^;
		mov		cx, BOOT_LOAD + SECT_SIZE		; CX = ̃[hAhX;

		cdecl	read_chs, BOOT, bx, cx			; AX = read_chs(.chs, bx, cx);

		cmp		ax, bx							; if (AX != c̃ZN^)
.10Q:	jz		.10E							; {
.10T:	cdecl	puts, .e0						;   puts(.e0);
		call	reboot							;   reboot(); // ċN
.10E:											; }

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_2							; u[g̑2Xe[W

		;---------------------------------------
		; f[^
		;---------------------------------------
.s0		db	"Booting...", 0x0A, 0x0D, 0
.e0		db	"Error:sector read", 0

;************************************************************************
;	u[ghCuɊւ
;************************************************************************
ALIGN 2, db 0
BOOT:											; u[ghCuɊւ
	istruc	drive
		at	drive.no,		dw	0				; hCuԍ
		at	drive.cyln,		dw	0				; C:V_
		at	drive.head,		dw	0				; H:wbh
		at	drive.sect,		dw	2				; S:ZN^
	iend

;************************************************************************
;	W[
;************************************************************************
%include	"../modules/real/puts.s"
%include	"../modules/real/reboot.s"
%include	"../modules/real/read_chs.s"

;************************************************************************
;	u[gtOi擪512oCg̏Ij
;************************************************************************
		times	510 - ($ - $$) db 0x00
		db	0x55, 0xAA

;************************************************************************
;	A[hɎ擾
;************************************************************************
FONT:											; tHg
.seg:	dw	0
.off:	dw	0
ACPI_DATA:										; ACPI data
.adr:	dd	0									; ACPI data address
.len:	dd	0									; ACPI data length

;************************************************************************
;	W[i擪512oCgȍ~ɔzuj
;************************************************************************
%include	"../modules/real/itoa.s"
%include	"../modules/real/get_drive_param.s"
%include	"../modules/real/get_font_adr.s"
%include	"../modules/real/get_mem_info.s"
%include	"../modules/real/kbc.s"
%include	"../modules/real/lba_chs.s"
%include	"../modules/real/read_lba.s"

;************************************************************************
;	u[g̑2Xe[W
;************************************************************************
stage_2:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0						; puts(.s0);

		;---------------------------------------
		; hCu擾
		;---------------------------------------
		cdecl	get_drive_param, BOOT			; get_drive_param(DX, BOOT.CYLN);
		cmp		ax, 0							; if (0 == AX)
.10Q:	jne		.10E							; {
.10T:	cdecl	puts, .e0						;   puts(.e0);
		call	reboot							;   reboot(); // ċN
.10E:											; }

		;---------------------------------------
		; hCu\
		;---------------------------------------
		mov		ax, [BOOT + drive.no]			; AX = u[ghCu;
		cdecl	itoa, ax, .p1, 2, 16, 0b0100	; 
		mov		ax, [BOOT + drive.cyln]			; 
		cdecl	itoa, ax, .p2, 4, 16, 0b0100	; 
		mov		ax, [BOOT + drive.head]			; AX = wbh;
		cdecl	itoa, ax, .p3, 2, 16, 0b0100	; 
		mov		ax, [BOOT + drive.sect]			; AX = gbÑZN^;
		cdecl	itoa, ax, .p4, 2, 16, 0b0100	; 
		cdecl	puts, .s1

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_3rd						; ̃Xe[Wֈڍs

		;---------------------------------------
		; f[^
		;---------------------------------------
.s0		db	"2nd stage...", 0x0A, 0x0D, 0

.s1		db	" Drive:0x"
.p1		db	"  , C:0x"
.p2		db	"    , H:0x"
.p3		db	"  , S:0x"
.p4		db	"  ", 0x0A, 0x0D, 0

.e0		db	"Can't get drive parameter.", 0

;************************************************************************
;	u[g̑3Xe[W
;************************************************************************
stage_3rd:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0

		;---------------------------------------
		; veNg[hŎgptHǵA
		; BIOSɓꂽ̂𗬗p
		;---------------------------------------
		cdecl	get_font_adr, FONT				; // BIOS̃tHgAhX擾

		;---------------------------------------
		; tHgAhX̕\
		;---------------------------------------
		cdecl	itoa, word [FONT.seg], .p1, 4, 16, 0b0100
		cdecl	itoa, word [FONT.off], .p2, 4, 16, 0b0100
		cdecl	puts, .s1

		;---------------------------------------
		; ̎擾ƕ\
		;---------------------------------------
		cdecl	get_mem_info					; get_mem_info();

		mov		eax, [ACPI_DATA.adr]			; EAX = ACPI_DATA.adr;
		cmp		eax, 0							; if (EAX)
		je		.10E							; {

		cdecl	itoa, ax, .p4, 4, 16, 0b0100	;   itoa(AX); // ʃAhXϊ
		shr		eax, 16							;   EAX >>= 16;
		cdecl	itoa, ax, .p3, 4, 16, 0b0100	;   itoa(AX); // ʃAhXϊ

		cdecl	puts, .s2						;   puts(.s2); // AhX\
.10E:											; }

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_4							; ̃Xe[Wֈڍs

		;---------------------------------------
		; f[^
		;---------------------------------------
.s0:	db	"3rd stage...", 0x0A, 0x0D, 0

.s1:	db	" Font Address="
.p1:	db	"ZZZZ:"
.p2:	db	"ZZZZ", 0x0A, 0x0D, 0
		db	0x0A, 0x0D, 0

.s2:	db	" ACPI data="
.p3:	db	"ZZZZ"
.p4:	db	"ZZZZ", 0x0A, 0x0D, 0

;************************************************************************
;	u[g̑4Xe[W
;************************************************************************
stage_4:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0

		;---------------------------------------
		; A20Q[g̗L
		;---------------------------------------
		cli										;   // 荞݋֎~
												;   
		cdecl	KBC_Cmd_Write, 0xAD				;   // L[{[h
												;   
		cdecl	KBC_Cmd_Write, 0xD0				;   // o̓|[gǂݏoR}h
		cdecl	KBC_Data_Read, .key				;   // o̓|[gf[^
												;   
		mov		bl, [.key]						;   BL  = key;
		or		bl, 0x02						;   BL |= 0x02; // A20Q[gL
												;   
		cdecl	KBC_Cmd_Write, 0xD1				;   // o̓|[g݃R}h
		cdecl	KBC_Data_Write, bx				;   // o̓|[gf[^
												;   
		cdecl	KBC_Cmd_Write, 0xAE				;   // L[{[hL
												;   
		sti										;   // 荞݋

		;---------------------------------------
		; L[{[hLED̃eXg
		;---------------------------------------
		mov		bx, 0							; CX = LED̏l;
.10L:											; do
												; {
		mov		ah, 0x00						;   // L[͑҂
		int		0x16							;   AL = BIOS(0x16, 0x00);
												;   
		cmp		al, '1'							;   if (AL < '1')
		jb		.10E							;     break;
												;   
		cmp		al, '3'							;   if ('3' < AL)
		ja		.10E							;     break;
												;   
		mov		cl, al							;   CL   = L[;
		dec		cl								;   CL  -= 1;       // 1Z
		and		cl, 0x03						;   CL  &= 0x03;    // 0`2ɐ
		mov		ax, 0x0001						;   AX   = 0x0001;  // rbgϊp
		shl		ax, cl							;   AX <<= CL;      // 0`2rbgVtg
		xor		bx, ax							;   BX  ^= AX;      // rbg]

		;---------------------------------------
		; LEDR}h̑M
		;---------------------------------------
		cli										;   // 荞݋֎~
												;   
		cdecl	KBC_Cmd_Write, 0xAD				;   // L[{[h
												;   
		cdecl	KBC_Data_Write, 0xED			;   // LEDR}h
		cdecl	KBC_Data_Read, .key				;   // M
												;   
		cmp		[.key], byte 0xFA				;   if (0xFA == key)
		jne		.11F							;   {
												;     
		cdecl	KBC_Data_Write, bx				;     // LEDf[^o
												;   }
		jmp		.11E							;   else
.11F:											;   {
		cdecl	itoa, word [.key], .e1, 2, 16, 0b0100
		cdecl	puts, .e0						;     // MR[h\
.11E:											;   }
												;   
		cdecl	KBC_Cmd_Write, 0xAE				;   // L[{[hL
												;   
		sti										;   // 荞݋
												;   
		jmp		.10L							; } while (1);
.10E:

		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s1

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_5							; ̃Xe[Wֈڍs

.s0:	db	"4th stage...", 0x0A, 0x0D, 0
.s1:	db	" A20 Gate Enabled.", 0x0A, 0x0D, 0
.e0:	db	"["
.e1:	db	"ZZ]", 0

.key:	dw	0

;************************************************************************
;	u[g̑5Xe[W
;************************************************************************
stage_5:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0

		;---------------------------------------
		; J[lǂݍ
		;---------------------------------------
		cdecl	read_lba, BOOT, BOOT_SECT, KERNEL_SECT, BOOT_END
												; AX = read_lba(.lba, ...);
		cmp		ax, KERNEL_SECT					; if (AX != CX)
.10Q:	jz		.10E							; {
.10T:	cdecl	puts, .e0						;   puts(.e0);
		call	reboot							;   reboot(); // ċN
.10E:											; }
												; 

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_6							; ̃Xe[Wֈڍs

.s0		db	"5th stage...", 0x0A, 0x0D, 0
.e0		db	" Failure load kernel...", 0x0A, 0x0D, 0

;************************************************************************
;	u[g̑6Xe[W
;************************************************************************
stage_6:
		;---------------------------------------
		; \
		;---------------------------------------
		cdecl	puts, .s0

		;---------------------------------------
		; [U[̓͑҂
		;---------------------------------------
.10L:											; do
												; {
		mov		ah, 0x00						;   // L[͑҂
		int		0x16							;   AL = BIOS(0x16, 0x00);
		cmp		al, ' '							;   ZF = AL == ' ';
		jne		.10L							; } while (!ZF);
												; 

		;---------------------------------------
		; rfI[h̐ݒ
		;---------------------------------------
		mov		ax, 0x0012						; VGA 640x480
		int		0x10							; BIOS(0x10, 0x12); // rfI[h̐ݒ

		;---------------------------------------
		; ̃Xe[Wֈڍs
		;---------------------------------------
		jmp		stage_7							; ̃Xe[Wֈڍs

.s0		db	"6th stage...", 0x0A, 0x0D, 0x0A, 0x0D
		db	" [Push SPACE key to protect mode...]", 0x0A, 0x0D, 0

;************************************************************************
;	GLOBAL DESCRIPTOR TABLE
;	(ZOgfBXNv^̔z)
;************************************************************************
;
;   ZOgfBXNv^
;
;        +--------+-----------------: Base (0xBBbbbbbb)
;        |   +----|--------+--------: Limit(0x000Lllll)
;        |   |    |        |
;       +--+--+--+--+--+--+--+--+
;       |B |FL|f |b       |l    |
;       +--+--+--+--+--+--+--+--+
;           |  |                         76543210
;           |  +--------------------: f:PDDSTTTA
;           |                          P:Exist
;           |                          D:DPL()
;           |                          S:(DT)0=VXeorQ[g, 1=f[^ZOg
;           |                          T:Type
;           |                            000(0)=R/- DATA
;           |                            001(1)=R/W DATA
;           |                            010(2)=R/- STACK
;           |                            011(3)=R/W STACK
;           |                            100(4)=R/- CODE
;           |                            101(5)=R/W CODE
;           |                            110(6)=R/- CONFORM
;           |                            111(7)=R/W CONFORM
;           |                          A:Accessed
;           |                       
;           +-----------------------: F:GD0ALLLL
;                                      G:Limit Scale(0=1, 1=4K)
;                                      D:Data/BandDown(0=16, 1=32Bit ZOg)
;                                      A:any
;                                      L:Limit[19:16]
ALIGN 4, db 0
;					  B_ F L f T b_____ l___
GDT:			dq	0x00_0_0_0_0_000000_0000	; NULL
.cs:			dq	0x00_C_F_9_A_000000_FFFF	; CODE 4G
.ds:			dq	0x00_C_F_9_2_000000_FFFF	; DATA 4G
.gdt_end:

;===============================================
;	ZN^
;===============================================
SEL_CODE	equ	.cs - GDT						; R[hpZN^
SEL_DATA	equ	.ds - GDT						; f[^pZN^

;===============================================
;	GDT
;===============================================
GDTR:	dw 		GDT.gdt_end - GDT - 1			; fBXNv^e[ũ~bg
		dd 		GDT								; fBXNv^e[ũAhX

;===============================================
;	IDTi^F荞݋֎~ɂׁj
;===============================================
IDTR:	dw 		0								; idt_limit
		dd 		0								; idt location

;************************************************************************
;	u[g̑7Xe[W
;************************************************************************
stage_7:
		cli										; // 荞݋֎~

		;---------------------------------------
		; GDT[h
		;---------------------------------------
		lgdt	[GDTR]							; // O[ofBXNv^e[u[h
		lidt	[IDTR]							; // 荞݃fBXNv^e[u[h

		;---------------------------------------
		; veNg[hֈڍs
		;---------------------------------------
		mov		eax,cr0							; // PErbgZbg
		or		ax, 1							; CR0 |= 1;
		mov		cr0,eax							; 

		jmp		$ + 2							; ǂ݂NA

		;---------------------------------------
		; ZOgԃWv
		;---------------------------------------
[BITS 32]
		DB		0x66							; IyhTCYI[o[ChvtBbNX
		jmp		SEL_CODE:CODE_32

;************************************************************************
;	32rbgR[hJn
;************************************************************************
CODE_32:

		;---------------------------------------
		; ZN^
		;---------------------------------------
		mov		ax, SEL_DATA					;
		mov		ds, ax							;
		mov		es, ax							;
		mov		fs, ax							;
		mov		gs, ax							;
 		mov		ss, ax							;

		;---------------------------------------
		; J[lRs[
		;---------------------------------------
		mov		ecx, (KERNEL_SIZE) / 4			; ECX = 4oCgPʂŃRs[;
		mov		esi, BOOT_END					; ESI = 0x0000_9C00; // J[l
		mov		edi, KERNEL_LOAD				; EDI = 0x0010_1000; // ʃ
		cld										; // DFNAi+j
		rep movsd								; while (--ECX) *EDI++ = *ESI++;

		;---------------------------------------
		; J[lɈڍs
		;---------------------------------------
		jmp		KERNEL_LOAD						; J[l̐擪ɃWv


;************************************************************************
;	pfBO
;************************************************************************
		times BOOT_SIZE - ($ - $$)		db	0	; pfBO

